gtkmm: Gtk::ListViewText Class Reference

gtkmm 4.22.0

Classes | Public Types | Public Member Functions | Protected Attributes | List of all members
Gtk::ListViewText Class Reference
Widgets | Container Widgets | TreeView Classes

A simple listbox which presents some lines of information in columns and lets the user select some of them. More...

`#include <gtkmm/listviewtext.h>`

Inheritance diagram for Gtk::ListViewText:
[legend]

## Classes
class | TextModelColumns

## Public Types
typedef std::vector< int > | SelectionList
Public Types inherited from Gtk::TreeView
enum class | DropPosition { DropPosition::BEFORE , DropPosition::AFTER , DropPosition::INTO_OR_BEFORE , DropPosition::INTO_OR_AFTER }
| An enum for determining where a dropped row goes. More...
enum class | GridLines { GridLines::NONE , GridLines::HORIZONTAL , GridLines::VERTICAL , GridLines::BOTH }
| Used to indicate which grid lines to draw in a tree view. More...
typedef TreeViewColumn | Column
| A visible column in a Gtk::TreeView widget.
typedef TreeSelection | Selection
| A selection object for Gtk::TreeView.
typedef TreeViewColumn::SlotTreeCellData | SlotTreeCellData
typedef sigc::slot< bool(TreeView *, TreeViewColumn *, TreeViewColumn *, TreeViewColumn *)> | SlotColumnDrop
| For instance, bool on_column_drop(TreeView*, tree_view, TreeViewColumn* column, TreeViewColumn* prev_column, TreeViewColumn* next_column).
typedef sigc::slot< void(TreeView *, const TreeModel::Path &)> | SlotMapping
| For example, void on_map_expanded_rows(TreeView* tree_view, const TreeModel::Path& path);.
typedef sigc::slot< bool(const Glib::RefPtr< TreeModel > &, const TreeModel::const_iterator &)> | SlotRowSeparator
| The slot type for determining whether the row pointed to by the iterator should be rendered as a separator.
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural<Requisition>
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE , Relation::LABEL_FOR , Relation::DESCRIPTION_FOR , Relation::CONTROLLED_BY , Relation::DETAILS_FOR , Relation::ERROR_MESSAGE_FOR , Relation::FLOW_FROM }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Public Types inherited from Gtk::Scrollable
enum class | Policy { Policy::MINIMUM , Policy::NATURAL }
| Defines the policy to be used in a scrollable widget when updating the scrolled window adjustments in a given orientation. More...

## Public Member Functions
| ListViewText (guint columns_count, bool editable=false, Gtk::SelectionMode mode=Gtk::SelectionMode::SINGLE)
| ~ListViewText () noexcept override
void | set_column_title (guint column, const Glib::ustring & title)
| Adds a title to column column.
Glib::ustring | get_column_title (guint column) const
| Gets the title of column column.
guint | append (const Glib::ustring & column_one_value={})
| Add a new row at the end of the list.
void | prepend (const Glib::ustring & column_one_value={})
| Insert a new row at the beginning of the list.
void | insert (guint row, const Glib::ustring & column_one_value={})
| Insert a new row at an arbitrary position in the list.
void | clear_items ()
| Discard all row:
Glib::ustring | get_text (guint row, guint column=0) const
| Obtain the value of an existing cell from the list.
void | set_text (guint row, guint column, const Glib::ustring & value)
| Change an existing value of cell of the list.
void | set_text (guint row, const Glib::ustring & value)
| Change an existing value of a column 0 of a row of the list.
guint | size () const
guint | get_num_columns () const
SelectionList | get_selected ()
| Returns a vector of the indexes of the selected rows.
Public Member Functions inherited from Gtk::TreeView
| TreeView (TreeView && src) noexcept
TreeView & | operator= (TreeView && src) noexcept
| TreeView (const TreeView &)=delete
TreeView & | operator= (const TreeView &)=delete
| ~TreeView () noexcept override
GtkTreeView * | gobj ()
| Provides access to the underlying C GObject.
const GtkTreeView * | gobj () const
| Provides access to the underlying C GObject.
| TreeView ()
| Default constructor.
| TreeView (const Glib::RefPtr< TreeModel > & model)
| Constructor that binds to a TreeModel.
Glib::RefPtr< TreeModel > | get_model ()
| Returns the model the Gtk::TreeView is based on.
Glib::RefPtr< const TreeModel > | get_model () const
| Returns the model the Gtk::TreeView is based on.
void | set_model (const Glib::RefPtr< TreeModel > & model)
| Sets the model for a Gtk::TreeView.
void | unset_model ()
| Remove the model from the TreeView.
Glib::RefPtr< TreeSelection > | get_selection ()
| Gets the Gtk::TreeSelection associated with tree_view.
Glib::RefPtr< const TreeSelection > | get_selection () const
| Gets the Gtk::TreeSelection associated with tree_view.
bool | get_headers_visible () const
| Returns true if the headers on the tree_view are visible.
void | set_headers_visible (bool headers_visible=true)
| Sets the visibility state of the headers.
void | columns_autosize ()
| Resizes all columns to their optimal width.
bool | get_headers_clickable () const
| Returns whether all header columns are clickable.
void | set_headers_clickable (bool setting=true)
| Allow the column title buttons to be clicked.
void | set_activate_on_single_click (bool single=true)
| Cause the Gtk::TreeView::row-activated signal to be emitted on a single click instead of a double click.
bool | get_activate_on_single_click () const
| Gets the setting set by set_activate_on_single_click().
int | append_column (TreeViewColumn & column)
| Appends column to the list of columns.
template<class ColumnType>
int | append_column_numeric (const Glib::ustring & title, const TreeModelColumn< ColumnType > & model_column, const Glib::ustring & format)
| Appends a View column with the appropriate CellRenderer for the Model column.
template<class ColumnType>
int | append_column_editable (const Glib::ustring & title, const TreeModelColumn< ColumnType > & model_column)
| Appends a View column with the appropriate CellRenderer for the Model column.
template<class ColumnType>
int | append_column_numeric_editable (const Glib::ustring & title, const TreeModelColumn< ColumnType > & model_column, const Glib::ustring & format)
| Like append_column_editable(), but only for numeric types, which will be displayed in the specified format.
* Creates a View column containing the and appends it int | append_column (const Glib::ustring & title, CellRenderer & cell)
int | remove_column (TreeViewColumn & column)
| Removes column from tree_view.
* Removes all View columns void | remove_all_columns ()
int | insert_column (TreeViewColumn & column, int position)
| This inserts the column into the tree_view at position.
int | insert_column (const Glib::ustring & title, CellRenderer & cell, int position)
| Creates a View column containing the CellRenderer, and inserts it.
template<class ColumnType>
int | insert_column (const Glib::ustring & title, const TreeModelColumn< ColumnType > & model_column, int position)
| Inserts a View column with the appropriate CellRenderer for the Model column.
template<class ColumnType>
int | insert_column_editable (const Glib::ustring & title, const TreeModelColumn< ColumnType > & model_column, int position)
| Inserts a View column with the appropriate CellRenderer for the Model column.
int | insert_column_with_data_func (int position, const Glib::ustring & title, CellRenderer & cell, const SlotTreeCellData & slot)
| Inserts a new column into the TreeView with the given cell renderer and a SlotTreeCellData to set cell renderer attributes (normally using data from the model).
guint | get_n_columns () const
| Queries the number of columns in the given tree_view.
TreeViewColumn * | get_column (int n)
| Gets the Gtk::TreeViewColumn at the given position in the #tree_view.
const TreeViewColumn * | get_column (int n) const
| Gets the Gtk::TreeViewColumn at the given position in the #tree_view.
CellRenderer * | get_column_cell_renderer (int n)
| Gets the CellRenderer for that column.
const CellRenderer * | get_column_cell_renderer (int n) const
| Gets the CellRenderer for that column.
std::vector< TreeViewColumn * > | get_columns ()
| Returns a list of all the Gtk::TreeViewColumn s currently in tree_view.
std::vector< const TreeViewColumn * > | get_columns () const
| Returns a list of all the Gtk::TreeViewColumn s currently in tree_view.
void | move_column_after (TreeViewColumn & column, TreeViewColumn & base_column)
| Moves column to be after to base_column.
void | move_column_to_start (TreeViewColumn & column)
| This method moves column to the first position in the view.
void | set_expander_column (TreeViewColumn & column)
| Sets the column to draw the expander arrow at.
void | reset_expander_column ()
| This method resets the expander arrow to the default - the first visible column.
TreeViewColumn * | get_expander_column ()
| Returns the column that is the current expander column, or nullptr if none has been set.
const TreeViewColumn * | get_expander_column () const
| Returns the column that is the current expander column, or nullptr if none has been set.
void | set_column_drag_function (const SlotColumnDrop & slot)
| Sets a callback slot for determining where a column may be dropped when dragged.
void | unset_column_drag_function ()
| See set_column_drag_function().
void | scroll_to_point (int tree_x, int tree_y)
| Scrolls the tree view such that the top-left corner of the visible area is tree_x, tree_y, where tree_x and tree_y are specified in tree coordinates.
void | scroll_to_cell (const TreeModel::Path & path, TreeViewColumn & column, float row_align, float col_align)
| Moves the alignments of tree view to the position specified by column and path.
void | scroll_to_cell (const TreeModel::Path & path, TreeViewColumn & column)
| Moves the alignments of tree view to the position specified by column and path.
void | scroll_to_row (const TreeModel::Path & path, float row_align)
| Moves the alignments of tree view to the position specified by path.
void | scroll_to_row (const TreeModel::Path & path)
| Moves the alignments of tree view to the position specified by path.
void | scroll_to_column (TreeViewColumn & column, float col_align)
| Moves the alignments of tree view to the position specified by column.
void | scroll_to_column (TreeViewColumn & column)
| Moves the alignments of tree view to the position specified by column.
void | row_activated (const TreeModel::Path & path, TreeViewColumn & column)
| Activates the cell determined by path and column.
void | expand_all ()
| Recursively expands all nodes in the tree_view.
void | collapse_all ()
| Recursively collapses all visible, expanded nodes in tree_view.
void | expand_to_path (const TreeModel::Path & path)
| Expands the row at path.
bool | expand_row (const TreeModel::Path & path, bool open_all)
| Opens the row so its children are visible.
bool | collapse_row (const TreeModel::Path & path)
| Collapses a row (hides its child rows, if they exist).
void | map_expanded_rows (const SlotMapping & slot)
| Calls the callback slot on all expanded rows.
bool | row_expanded (const TreeModel::Path & path)
| Returns true if the node pointed to by path is expanded in tree_view.
void | set_reorderable (bool reorderable=true)
| This function is a convenience function to allow you to reorder models that support the Gtk::TreeDragSourceIface and the Gtk::TreeDragDestIface.
bool | get_reorderable () const
| Retrieves whether the user can reorder the tree via drag-and-drop.
void | set_cursor (const TreeModel::Path & path, TreeViewColumn & focus_column, bool start_editing=false)
| Sets the current keyboard focus to be at path, and selects it.
void | set_cursor (const TreeModel::Path & path, TreeViewColumn & focus_column, CellRenderer & focus_cell, bool start_editing=false)
| Sets the current keyboard focus to be at path, and selects it.
void | set_cursor (const TreeModel::Path & path)
| Sets the current keyboard focus to be at path , and selects it.
void | get_cursor (TreeModel::Path & path, TreeViewColumn *& focus_column)
| Fills in path and focus_column with the current path and focus column.
bool | get_path_at_pos (int x, int y, TreeModel::Path & path, TreeViewColumn *& column, int & cell_x, int & cell_y) const
| Finds the path at the point (x, y), relative to bin_window coordinates.
bool | get_path_at_pos (int x, int y, TreeModel::Path & path) const
| Finds the path at the point (x, y), relative to bin_window coordinates.
void | get_cell_area (const TreeModel::Path & path, TreeViewColumn & column, Gdk::Rectangle & rect) const
| Fills the bounding rectangle in tree window coordinates for the cell at the row specified by path and the column specified by column.
void | get_background_area (const TreeModel::Path & path, TreeViewColumn & column, Gdk::Rectangle & rect) const
| Fills the bounding rectangle in tree window coordinates for the cell at the row specified by path and the column specified by column.
void | get_visible_rect (Gdk::Rectangle & visible_rect) const
| Fills visible_rect with the currently-visible region of the buffer, in tree coordinates.
bool | get_visible_range (TreeModel::Path & start_path, TreeModel::Path & end_path) const
bool | is_blank_at_pos (int x, int y, TreePath & path, TreeViewColumn *& column, int & cell_x, int & cell_y) const
| Determine whether the point (x, y) in the tree view is blank, that is no cell content nor an expander arrow is drawn at the location.
bool | is_blank_at_pos (int x, int y) const
| Determine whether the point (x, y) in the tree view is blank, that is no cell content nor an expander arrow is drawn at the location.
void | enable_model_drag_source (const Glib::RefPtr< const Gdk::ContentFormats > & formats, Gdk::ModifierType start_button_mask=static_cast< Gdk::ModifierType >(GDK_MODIFIER_MASK), Gdk::DragAction actions=Gdk::DragAction::COPY|Gdk::DragAction::MOVE)
| Turns tree_view into a drag source for automatic DND.
void | enable_model_drag_source (Gdk::ModifierType start_button_mask=static_cast< Gdk::ModifierType >(GDK_MODIFIER_MASK), Gdk::DragAction actions=Gdk::DragAction::COPY|Gdk::DragAction::MOVE)
| Turns the TreeView into a drag source for automatic DND.
void | enable_model_drag_dest (const Glib::RefPtr< const Gdk::ContentFormats > & formats, Gdk::DragAction actions=Gdk::DragAction::COPY|Gdk::DragAction::MOVE)
| Turns tree_view into a drop destination for automatic DND.
void | enable_model_drag_dest (Gdk::DragAction actions=Gdk::DragAction::COPY|Gdk::DragAction::MOVE)
| Turns the TreeView into a drop destination for automatic DND.
void | unset_rows_drag_source ()
| Undoes the effect of enable_model_drag_source().
void | unset_rows_drag_dest ()
| Undoes the effect of enable_model_drag_dest().
void | set_drag_dest_row (const TreeModel::Path & path, DropPosition pos)
| Sets the row that is highlighted for feedback.
void | unset_drag_dest_row ()
| Remove an existing highlight.
void | get_drag_dest_row (TreeModel::Path & path, DropPosition & pos) const
| Gets information about the row that is highlighted for feedback.
bool | get_dest_row_at_pos (int drag_x, int drag_y, TreeModel::Path & path, DropPosition & pos) const
| Determines the destination row for a given position.
Glib::RefPtr< Gdk::Paintable > | create_row_drag_icon (const TreeModel::Path & path) const
| Creates a cairo_surface_t representation of the row at path.
void | set_enable_search (bool enable_search=true)
| If enable_search is set, then the user can type in text to search through the tree interactively (this is sometimes called "typeahead find").
bool | get_enable_search () const
| Returns whether or not the tree allows to start interactive searching by typing in text.
int | get_search_column () const
| Gets the column searched on by the interactive search code.
void | set_search_column (const TreeModelColumnBase & column)
| Sets column as the column where the interactive search code should search in for the current model.
void | set_search_column (int column)
| Sets column as the column where the interactive search code should search in for the current model.
Editable * | get_search_entry ()
| Returns the Gtk::Entry which is currently in use as interactive search entry for tree_view.
const Editable * | get_search_entry () const
| Returns the Gtk::Entry which is currently in use as interactive search entry for tree_view.
void | set_search_entry (Editable & entry)
| Sets the entry which the interactive search code will use for this tree_view.
void | convert_widget_to_tree_coords (int wx, int wy, int & tx, int & ty) const
| Converts widget coordinates to coordinates for the tree (the full scrollable area of the tree).
void | convert_tree_to_widget_coords (int tx, int ty, int & wx, int & wy) const
| Converts tree coordinates (coordinates in full scrollable area of the tree) to widget coordinates.
void | convert_widget_to_bin_window_coords (int wx, int wy, int & bx, int & by) const
| Converts widget coordinates to coordinates for the bin_window.
void | convert_bin_window_to_widget_coords (int bx, int by, int & wx, int & wy) const
| Converts bin_window coordinates to widget relative coordinates.
void | convert_tree_to_bin_window_coords (int tx, int ty, int & bx, int & by) const
| Converts tree coordinates (coordinates in full scrollable area of the tree) to bin_window coordinates.
void | convert_bin_window_to_tree_coords (int bx, int by, int & tx, int & ty) const
| Converts bin_window coordinates to coordinates for the tree (the full scrollable area of the tree).
void | set_fixed_height_mode (bool enable=true)
| Enables or disables the fixed height mode of tree_view.
bool | get_fixed_height_mode () const
| Returns whether fixed height mode is turned on for tree_view.
void | set_hover_selection (bool hover=true)
| Enables or disables the hover selection mode of tree_view.
bool | get_hover_selection () const
| Returns whether hover selection mode is turned on for tree_view.
void | set_hover_expand (bool expand=true)
| Enables or disables the hover expansion mode of tree_view.
bool | get_hover_expand () const
| Returns whether hover expansion mode is turned on for tree_view.
void | set_rubber_banding (bool enable=true)
| Enables or disables rubber banding in tree_view.
bool | get_rubber_banding () const
| Returns whether rubber banding is turned on for tree_view.
bool | is_rubber_banding_active () const
| Returns whether a rubber banding operation is currently being done in tree_view.
void | set_row_separator_func (const SlotRowSeparator & slot)
| Sets the row separator function, which is used to determine whether a row should be drawn as a separator.
void | unset_row_separator_func ()
| Removes the row separator function, so no separators are drawn.
void | set_grid_lines (GridLines grid_lines)
| Sets which grid lines to draw in tree_view.
GridLines | get_grid_lines () const
| Returns which grid lines are enabled in tree_view.
void | set_enable_tree_lines (bool enable=true)
| Sets whether to draw lines interconnecting the expanders in tree_view.
bool | get_enable_tree_lines () const
| Returns whether or not tree lines are drawn in tree_view.
void | set_show_expanders (bool enabled=true)
| Sets whether to draw and enable expanders and indent child rows in tree_view.
bool | get_show_expanders () const
| Returns whether or not expanders are drawn in tree_view.
void | set_level_indentation (int indentation)
| Sets the amount of extra indentation for child levels to use in tree_view in addition to the default indentation.
int | get_level_indentation () const
| Returns the amount, in pixels, of extra indentation for child levels in tree_view.
void | set_tooltip_row (const Glib::RefPtr< Tooltip > & tooltip, const TreePath & path)
| Sets the tip area of tooltip to be the area covered by the row at path.
void | set_tooltip_cell (const Glib::RefPtr< Tooltip > & tooltip, const TreeModel::Path * path, TreeViewColumn * column, CellRenderer * cell)
| Sets the tip area of tooltip to the area path, column and cell have in common.
bool | get_tooltip_context_path (int x, int y, bool keyboard_tip, TreeModel::Path & path)
| This function is supposed to be used in a Gtk::Widget::query-tooltip signal handler for Gtk::TreeView.
bool | get_tooltip_context_iter (int x, int y, bool keyboard_tip, Gtk::TreeModel::iterator & iter)
| This function is supposed to be used in a Gtk::Widget::query-tooltip signal handler for Gtk::TreeView.
void | set_tooltip_column (int column)
| If you only plan to have simple (text-only) tooltips on full rows, you can use this function to have Gtk::TreeView handle these automatically for you.
int | get_tooltip_column () const
| Returns the column of tree_view’s model which is being used for displaying tooltips on tree_view’s rows.
Glib::SignalProxy< void(const TreeModel::Path &, TreeViewColumn *)> | signal_row_activated ()
Glib::SignalProxy< bool(const TreeModel::iterator &, const TreeModel::Path &)> | signal_test_expand_row ()
Glib::SignalProxy< bool(const TreeModel::iterator &, const TreeModel::Path &)> | signal_test_collapse_row ()
Glib::SignalProxy< void(const TreeModel::iterator &, const TreeModel::Path &)> | signal_row_expanded ()
Glib::SignalProxy< void(const TreeModel::iterator &, const TreeModel::Path &)> | signal_row_collapsed ()
Glib::SignalProxy< void()> | signal_cursor_changed ()
Glib::SignalProxy< void()> | signal_columns_changed ()
Glib::PropertyProxy< Glib::RefPtr< TreeModel > > | property_model ()
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TreeModel > > | property_model () const
Glib::PropertyProxy< bool > | property_headers_visible ()
| Default value: true.
Glib::PropertyProxy_ReadOnly< bool > | property_headers_visible () const
| Default value: true.
Glib::PropertyProxy< bool > | property_headers_clickable ()
| Default value: true.
Glib::PropertyProxy_ReadOnly< bool > | property_headers_clickable () const
| Default value: true.
Glib::PropertyProxy< TreeViewColumn * > | property_expander_column ()
Glib::PropertyProxy_ReadOnly< TreeViewColumn * > | property_expander_column () const
Glib::PropertyProxy< bool > | property_reorderable ()
| Default value: false.
Glib::PropertyProxy_ReadOnly< bool > | property_reorderable () const
| Default value: false.
Glib::PropertyProxy< bool > | property_enable_search ()
| Default value: true.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_search () const
| Default value: true.
Glib::PropertyProxy< int > | property_search_column ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_search_column () const
| Default value: -1.
Glib::PropertyProxy< bool > | property_fixed_height_mode ()
| Setting the property_fixed_height_mode() property to true speeds up Gtk::TreeView by assuming that all rows have the same height.
Glib::PropertyProxy_ReadOnly< bool > | property_fixed_height_mode () const
| Setting the property_fixed_height_mode() property to true speeds up Gtk::TreeView by assuming that all rows have the same height.
Glib::PropertyProxy< bool > | property_hover_selection ()
| Enables or disables the hover selection mode of tree_view.
Glib::PropertyProxy_ReadOnly< bool > | property_hover_selection () const
| Enables or disables the hover selection mode of tree_view.
Glib::PropertyProxy< bool > | property_hover_expand ()
| Enables or disables the hover expansion mode of tree_view.
Glib::PropertyProxy_ReadOnly< bool > | property_hover_expand () const
| Enables or disables the hover expansion mode of tree_view.
Glib::PropertyProxy< bool > | property_show_expanders ()
| true if the view has expanders.
Glib::PropertyProxy_ReadOnly< bool > | property_show_expanders () const
| true if the view has expanders.
Glib::PropertyProxy< bool > | property_level_indentation ()
| Extra indentation for each level.
Glib::PropertyProxy_ReadOnly< bool > | property_level_indentation () const
| Extra indentation for each level.
Glib::PropertyProxy< bool > | property_rubber_banding ()
| Default value: false.
Glib::PropertyProxy_ReadOnly< bool > | property_rubber_banding () const
| Default value: false.
Glib::PropertyProxy< bool > | property_enable_grid_lines ()
| Default value: Gtk::TreeView::GridLines::NONE.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_grid_lines () const
| Default value: Gtk::TreeView::GridLines::NONE.
Glib::PropertyProxy< bool > | property_enable_tree_lines ()
| Default value: false.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_tree_lines () const
| Default value: false.
Glib::PropertyProxy< int > | property_tooltip_column ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_tooltip_column () const
| Default value: -1.
Glib::PropertyProxy< bool > | property_activate_on_single_click ()
| The activate-on-single-click property specifies whether the "row-activated" signal will be emitted after a single click.
Glib::PropertyProxy_ReadOnly< bool > | property_activate_on_single_click () const
| The activate-on-single-click property specifies whether the "row-activated" signal will be emitted after a single click.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of [method.Gtk.Widget.show].
void | queue_draw ()
| Schedules this widget to be redrawn.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager to use for measuring and allocating children of the widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager of the widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager of the widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Sets whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter the widget or any of its children.
void | set_focusable (bool focusable=true)
| Sets whether the widget can own the input focus.
bool | get_focusable () const
| Determines whether the widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the window that it belongs to.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether the widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether the widget can be the target of pointer events.
bool | has_default () const
| Determines whether the widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Sets whether the widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether the widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of the widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether the widget can be drawn to.
bool | get_realized () const
| Determines whether the widget is realized.
bool | get_mapped () const
| Returns whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether the widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to the widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to the widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to the widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to the widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of the widget.
const Widget * | get_parent () const
| Returns the parent widget of the widget.
Root * | get_root ()
| Returns the Gtk::Root widget of the widget.
const Root * | get_root () const
| Returns the Gtk::Root widget of the widget.
Native * | get_native ()
| Returns the nearest Gtk::Native ancestor of the widget.
const Native * | get_native () const
| Returns the nearest Gtk::Native ancestor of the widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the signal_keynav_failed() signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on the widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of the widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget.
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Requests the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for the widget.
void | set_overflow (Overflow overflow)
| Sets how the widget treats content that is drawn outside the it's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of the widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of the widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the display for the window that the widget belongs to.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the display for the window that the widget belongs to.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of the widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether the hexpand flag has been explicitly set.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether the vexpand flag has been explicitly set.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a parent widget should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of the widget.
void | set_halign (Align align)
| Sets the horizontal alignment of the widget.
Align | get_valign () const
| Gets the vertical alignment of the widget.
void | set_valign (Align align)
| Sets the vertical alignment of the widget.
int | get_margin_start () const
| Gets the start margin of the widget.
void | set_margin_start (int margin)
| Sets the start margin of the widget.
int | get_margin_end () const
| Gets the end margin of the widget.
void | set_margin_end (int margin)
| Sets the end margin of the widget.
int | get_margin_top () const
| Gets the top margin of the widget.
void | set_margin_top (int margin)
| Sets the top margin of the widget.
int | get_margin_bottom () const
| Gets the bottom margin of the widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of the widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether the widget is a descendent of ancestor.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translates coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if a given point is contained in the widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of the widget closest to a point.
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of the widget closest to a point.
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds an event controller to the widget.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes an event controller from the widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context that is configured for the widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context that is configured for the widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the cairo_font_options_t used for text rendering in the widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the cairo_font_options_t of the widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new Pango::Layout that is configured for the widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on the widget.
TextDirection | get_direction () const
| Gets the reading direction for the widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when the pointer hovers over the widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Gets the cursor set on the widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Gets the cursor set on the widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets the parent widget of the widget.
void | unparent ()
| Removes widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display of the widget.
void | set_tooltip_text (const Glib::ustring & text)
| Sets the contents of the tooltip for the widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for the widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for the widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on the widget.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to the widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to the widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts an action group into the widget's actions.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the default.activate action for the widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for text rendering in the widget.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of the widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of the widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a list model to track the children of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a list model to track the children of the widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a list model to track the event controllers of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a list model to track the event controllers of the widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshots a child of the widget.
bool | should_layout () const
| Returns whether the widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name of the widget.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to the widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from the widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether a style class is currently applied to the widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to the widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Replaces the current style classes of the widget with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
void | set_limit_events (bool limit_events=true)
| Sets whether the widget acts like a modal dialog, with respect to event delivery.
bool | get_limit_events () const
| Gets the value of the property_limit_events() property.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The Gtk::Root widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Overrides for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Overrides for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Overrides for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Overrides for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy< bool > | property_limit_events ()
| Makes this widget act like a modal dialog, with respect to event delivery.
Glib::PropertyProxy_ReadOnly< bool > | property_limit_events () const
| Makes this widget act like a modal dialog, with respect to event delivery.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the implementation for the given accessible object.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the implementation for the given accessible object.
bool | get_platform_state (PlatformState state) const
| Queries a platform state, such as focus.
void | update_platform_state (PlatformState state)
| Informs ATs that the platform state has changed.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Glib::ustring | get_accessible_id () const
| Retrieves the accessible identifier for the accessible object.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given Gtk::Accessible implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given Gtk::Accessible implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Scrollable
| Scrollable (Scrollable && src) noexcept
Scrollable & | operator= (Scrollable && src) noexcept
| ~Scrollable () noexcept override
GtkScrollable * | gobj ()
| Provides access to the underlying C GObject.
const GtkScrollable * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< Adjustment > | get_hadjustment ()
| Retrieves the Gtk::Adjustment used for horizontal scrolling.
Glib::RefPtr< const Adjustment > | get_hadjustment () const
| Retrieves the Gtk::Adjustment used for horizontal scrolling.
void | set_hadjustment (const Glib::RefPtr< Adjustment > & hadjustment)
| Sets the horizontal adjustment of the Gtk::Scrollable.
void | unset_hadjustment ()
| This method removes the hadjustment.
Glib::RefPtr< Adjustment > | get_vadjustment ()
| Retrieves the Gtk::Adjustment used for vertical scrolling.
Glib::RefPtr< const Adjustment > | get_vadjustment () const
| Retrieves the Gtk::Adjustment used for vertical scrolling.
void | set_vadjustment (const Glib::RefPtr< Adjustment > & vadjustment)
| Sets the vertical adjustment of the Gtk::Scrollable.
void | unset_vadjustment ()
| This method removes the vadjustment.
Policy | get_hscroll_policy () const
| Gets the horizontal Gtk::Scrollable::Policy.
void | set_hscroll_policy (Policy policy)
| Sets the Gtk::Scrollable::Policy.
Policy | get_vscroll_policy () const
| Gets the vertical Gtk::Scrollable::Policy.
void | set_vscroll_policy (Policy policy)
| Sets the Gtk::Scrollable::Policy.
bool | get_border (Border & border) const
| Returns the size of a non-scrolling border around the outside of the scrollable.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_hadjustment ()
| Horizontal Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_hadjustment () const
| Horizontal Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_vadjustment ()
| Vertical Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_vadjustment () const
| Vertical Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy< Policy > | property_hscroll_policy ()
| Determines when horizontal scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_hscroll_policy () const
| Determines when horizontal scrolling should start.
Glib::PropertyProxy< Policy > | property_vscroll_policy ()
| Determines when vertical scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_vscroll_policy () const
| Determines when vertical scrolling should start.

## Protected Attributes
Glib::RefPtr< Gtk::ListStore > | m_model
TextModelColumns | m_model_columns

## Additional Inherited Members
Static Public Member Functions inherited from Gtk::TreeView
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Scrollable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Public Attributes inherited from Gtk::TreeView
* void on_search_equal(const Glib::RefPtr< TreeModel > & model, int column, const Glib::ustring & key, const TreeModel::const_iterator & iter) typedef sigc voi | set_search_equal_func )(const SlotSearchEqual & slot)
| Sets the compare function for the interactive search capabilities.
* Creates a View column containing the | CellRenderer
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized.
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set the focus child of the widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the focus child of the widget.
const Widget * | get_focus_child () const
| Returns the focus child of the widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Scrollable
| Scrollable ()
| You should derive from this class to use it.
virtual bool | get_border_vfunc (Border & border) const
Related Symbols inherited from Gtk::TreeView
Gtk::TreeView * | wrap (GtkTreeView * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Scrollable
Glib::RefPtr< Gtk::Scrollable > | wrap (GtkScrollable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A simple listbox which presents some lines of information in columns and lets the user select some of them.

This is a convenience class, based on Gtk::TreeView, which allows only text values and does not allow child items. In most cases you will actually need the functionality offered by a real Gtk::TreeView with your own type-safe Gtk::TreeModel::ColumnRecord.

Deprecated
  4.10: Use Gtk::ListView for lists, and Gtk::ColumnView for tabular lists.

## Member Typedef Documentation

## ◆ SelectionList

typedef std::vector<int> Gtk::ListViewText::SelectionList

## Constructor & Destructor Documentation

## ◆ ListViewText()

Gtk::ListViewText::ListViewText | ( | guint | columns_count,
|  | bool | editable = false,
|  | Gtk::SelectionMode | mode = Gtk::SelectionMode::SINGLE )

## ◆ ~ListViewText()

Gtk::ListViewText::~ListViewText | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ append()

guint Gtk::ListViewText::append | ( | const Glib::ustring & | column_one_value = {} | ) |

Add a new row at the end of the list.

Parameters

  column_one_value | the new text for the new row, column 0

Returns
  the number of the row added

## ◆ clear_items()

void Gtk::ListViewText::clear_items | ( |  | ) |

Discard all row:

## ◆ get_column_title()

Glib::ustring Gtk::ListViewText::get_column_title | ( | guint | column | ) | const

Gets the title of column column.

Parameters

  column | the column number.

Returns
  the title of column column.

## ◆ get_num_columns()

guint Gtk::ListViewText::get_num_columns | ( |  | ) | const

Returns
  the number of columns in the listbox

## ◆ get_selected()

SelectionList Gtk::ListViewText::get_selected | ( |  | ) |

Returns a vector of the indexes of the selected rows.

Returns
  a SelectionList with the selection results

## ◆ get_text()

Glib::ustring Gtk::ListViewText::get_text | ( | guint | row,
|  | guint | column = 0 ) const

Obtain the value of an existing cell from the list.

Parameters

  row | the number of the row in the listbox.
  column | the number of the column in the row.

Returns
  the value of that cell, if it exists.

## ◆ insert()

void Gtk::ListViewText::insert | ( | guint | row,
|  | const Glib::ustring & | column_one_value = {} )

Insert a new row at an arbitrary position in the list.

Parameters

  row | The row number
  column_one_value | the new text for the new row, column 0

## ◆ prepend()

void Gtk::ListViewText::prepend | ( | const Glib::ustring & | column_one_value = {} | ) |

Insert a new row at the beginning of the list.

Parameters

  column_one_value | the new text for the new row, column 0

## ◆ set_column_title()

void Gtk::ListViewText::set_column_title | ( | guint | column,
|  | const Glib::ustring & | title )

Adds a title to column column.

Parameters

  column | the column number.
  title | the title for column column.

## ◆ set_text() [1/2]

void Gtk::ListViewText::set_text | ( | guint | row,
|  | const Glib::ustring & | value )

Change an existing value of a column 0 of a row of the list.

Parameters

  row | the number of the row in the list.
  value | the new contents of column 0 of the row.

## ◆ set_text() [2/2]

void Gtk::ListViewText::set_text | ( | guint | row,
|  | guint | column,
|  | const Glib::ustring & | value )

Change an existing value of cell of the list.

Parameters

  row | the number of the row in the list.
  column | the number of the column in the row.
  value | the new contents of that row and column.

## ◆ size()

guint Gtk::ListViewText::size | ( |  | ) | const

Returns
  the number of rows in the listbox

## Member Data Documentation

## ◆ m_model

Glib::RefPtr<Gtk::ListStore> Gtk::ListViewText::m_model
| protected

## ◆ m_model_columns

TextModelColumns Gtk::ListViewText::m_model_columns
| protected